package cz.cca.training.dao;

import cz.cca.training.entity.ActionEO;
import java.util.List;

/**
 * <p>
 * Title: {@link ActionDAO}
 * </p>
 * <p>
 * Description: Interface with necessary methods for basic work about action.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 26. 3. 2015 11:45:53
 */
public interface ActionDAO {

    /**
     * @param entity action entity
     */
    void saveAction(final ActionEO entity);

    /**
     * @param entity action entity
     */
    void deleteAction(final ActionEO entity);

    /**
     * @param entity action entity
     * @return result about updated entity 
     */
    ActionEO updateAction(final ActionEO entity);

    /**
     * Get action according the identifier
     * 
     * @param id the identifier action
     * @return required action
     */
    ActionEO getAction(final int id);

    /**
     * Get all action.
     *
     * @return list of all action entities
     */
    List<ActionEO> getAllAction();

}
