package cz.cca.training.entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * <p>
 * Title: {@link CenterEO}
 * </p>
 * <p>
 * Description: The persistent class for the cca_centers database table.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 3. 2015 14:42:31
 */
@Entity
@Table(name = "cca_centers")
@NamedQueries({
    @NamedQuery(name = "CenterEO.all", query = "SELECT center FROM CenterEO center")})
public class CenterEO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    public static final String ALL = "CenterEO.all";
     
    @Id
    @Column(name = "id_center")
    private int idCenter;

    @Column(name = "code_center")
    private String codeCenter;

    @Column(name = "full_name_center")
    private String fullNameCenter;

    // bi-directional many-to-one association to CcaEmployeeEO
    @OneToMany(mappedBy = "ccaCenter")
    private List<EmployeeEO> ccaEmployees;

    public CenterEO() {}

    public int getIdCenter() {
            return this.idCenter;
    }

    public void setIdCenter(int idCenter) {
            this.idCenter = idCenter;
    }

    public String getCodeCenter() {
            return this.codeCenter;
    }

    public void setCodeCenter(String codeCenter) {
            this.codeCenter = codeCenter;
    }

    public String getFullNameCenter() {
            return this.fullNameCenter;
    }

    public void setFullNameCenter(String fullNameCenter) {
            this.fullNameCenter = fullNameCenter;
    }

    public List<EmployeeEO> getCcaEmployees() {
            return this.ccaEmployees;
    }

    public void setCcaEmployees(List<EmployeeEO> ccaEmployees) {
            this.ccaEmployees = ccaEmployees;
    }

    public EmployeeEO addCcaEmployee(EmployeeEO ccaEmployee) {
            getCcaEmployees().add(ccaEmployee);
            ccaEmployee.setCcaCenter(this);

            return ccaEmployee;
    }

    public EmployeeEO removeCcaEmployee(EmployeeEO ccaEmployee) {
            getCcaEmployees().remove(ccaEmployee);
            ccaEmployee.setCcaCenter(null);

            return ccaEmployee;
    }

}