package cz.cca.training.entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * <p>
 * Title: {@link CurrencyEO}
 * </p>
 * <p>
 * Description: The persistent class for the cca_currency database table.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 3. 2015 14:42:53
 */
@Entity
@Table(name = "cca_currency")
@NamedQueries({
    @NamedQuery(name = "CurrencyEO.all", query = "SELECT currency FROM CurrencyEO currency")})
public class CurrencyEO implements Serializable {
    private static final long serialVersionUID = 1L;

        public static final String ALL = "CurrencyEO.all";
        
    @Id
    @Column(name = "id_currency")
    private int idCurrency;

    @Column(name = "abbervivation_currency")
    private String abbervivationCurrency;

    private String currency;

    // bi-directional many-to-one association to CcaRealizationActionEO
    @OneToMany(mappedBy = "ccaCurrency")
    private List<RealizationActionEO> ccaRealizationActions;

    public CurrencyEO() {}

    public int getIdCurrency() {
        return this.idCurrency;
    }

    public void setIdCurrency(int idCurrency) {
        this.idCurrency = idCurrency;
    }

    public String getAbbervivationCurrency() {
        return this.abbervivationCurrency;
    }

    public void setAbbervivationCurrency(String abbervivationCurrency) {
        this.abbervivationCurrency = abbervivationCurrency;
    }

    public String getCurrency() {
        return this.currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public List<RealizationActionEO> getCcaRealizationActions() {
        return this.ccaRealizationActions;
    }

    public void setCcaRealizationActions(List<RealizationActionEO> ccaRealizationActions) {
        this.ccaRealizationActions = ccaRealizationActions;
    }

    public RealizationActionEO addCcaRealizationAction(RealizationActionEO ccaRealizationAction) {
        getCcaRealizationActions().add(ccaRealizationAction);
        ccaRealizationAction.setCcaCurrency(this);

        return ccaRealizationAction;
    }

    public RealizationActionEO removeCcaRealizationAction(RealizationActionEO ccaRealizationAction) {
        getCcaRealizationActions().remove(ccaRealizationAction);
        ccaRealizationAction.setCcaCurrency(null);

        return ccaRealizationAction;
    }

}