package cz.cca.training.entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * <p>
 * Title: {@link ExpressionEO}
 * </p>
 * <p>
 * Description: The persistent class for the cca_expression database table.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 3. 2015 14:44:47
 */
@Entity
@Table(name = "cca_expression")
@NamedQueries({
    @NamedQuery(name = "ExpressionEO.all", query = "SELECT expression FROM ExpressionEO expression")})
public class ExpressionEO implements Serializable {
    private static final long serialVersionUID = 1L;

        public static final String ALL = "ExpressionEO.all";
        
    @Id
    @Column(name = "id_expression")
    private int idExpression;

    private String expression;

    // bi-directional many-to-one association to CcaRegistrationEO
    @OneToMany(mappedBy = "ccaExpression")
    private List<RegistrationEO> ccaRegistrations;

    public ExpressionEO() {}

    public int getIdExpression() {
        return this.idExpression;
    }

    public void setIdExpression(int idExpression) {
        this.idExpression = idExpression;
    }

    public String getExpression() {
        return this.expression;
    }

    public void setExpression(String expression) {
        this.expression = expression;
    }

    public List<RegistrationEO> getCcaRegistrations() {
        return this.ccaRegistrations;
    }

    public void setCcaRegistrations(List<RegistrationEO> ccaRegistrations) {
        this.ccaRegistrations = ccaRegistrations;
    }

    public RegistrationEO addCcaRegistration(RegistrationEO ccaRegistration) {
        getCcaRegistrations().add(ccaRegistration);
        ccaRegistration.setCcaExpression(this);

        return ccaRegistration;
    }

    public RegistrationEO removeCcaRegistration(RegistrationEO ccaRegistration) {
        getCcaRegistrations().remove(ccaRegistration);
        ccaRegistration.setCcaExpression(null);

        return ccaRegistration;
    }

}