package cz.cca.training.entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * <p>
 * Title: {@link StatusActionEO}
 * </p>
 * <p>
 * Description: The persistent class for the cca_status_action database table.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 3. 2015 14:44:13
 */
@Entity
@Table(name = "cca_status_action")
@NamedQueries({
    @NamedQuery(name = "StatusActionEO.all", query = "SELECT status FROM StatusActionEO status")})
public class StatusActionEO implements Serializable {
    private static final long serialVersionUID = 1L;

        public static final String ALL = "StatusActionEO.all";
        
    @Id
    @Column(name = "id_status_action")
    private int idStatusAction;

    @Column(name = "status_action")
    private String statusAction;

    // bi-directional many-to-one association to CcaRealizationActionEO
    @OneToMany(mappedBy = "ccaStatusAction")
    private List<RealizationActionEO> ccaRealizationActions;

    public StatusActionEO() {}

    public int getIdStatusAction() {
        return this.idStatusAction;
    }

    public void setIdStatusAction(int idStatusAction) {
        this.idStatusAction = idStatusAction;
    }

    public String getStatusAction() {
        return this.statusAction;
    }

    public void setStatusAction(String statusAction) {
        this.statusAction = statusAction;
    }

    public List<RealizationActionEO> getCcaRealizationActions() {
        return this.ccaRealizationActions;
    }

    public void setCcaRealizationActions(List<RealizationActionEO> ccaRealizationActions) {
        this.ccaRealizationActions = ccaRealizationActions;
    }

    public RealizationActionEO addCcaRealizationAction(RealizationActionEO ccaRealizationAction) {
        getCcaRealizationActions().add(ccaRealizationAction);
        ccaRealizationAction.setCcaStatusAction(this);

        return ccaRealizationAction;
    }

    public RealizationActionEO removeCcaRealizationAction(RealizationActionEO ccaRealizationAction) {
        getCcaRealizationActions().remove(ccaRealizationAction);
        ccaRealizationAction.setCcaStatusAction(null);

        return ccaRealizationAction;
    }

}