package cz.cca.training.entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * <p>
 * Title: {@link StatusRegistrationEO}
 * </p>
 * <p>
 * Description: The persistent class for the cca_status_registration database table.n
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 3. 2015 14:44:02
 */
@Entity
@Table(name = "cca_status_registration")
@NamedQueries({
    @NamedQuery(name = "StatusRegistrationEO.all", query = "SELECT status_registration FROM StatusRegistrationEO status_registration")})
public class StatusRegistrationEO implements Serializable {
    private static final long serialVersionUID = 1L;
  
        public static final String ALL = "StatusRegistrationEO.all";
        
    @Id
    @Column(name = "id_status_registration")
    private int idStatusRegistration;

    @Column(name = "status_registration")
    private String statusRegistration;

    // bi-directional many-to-one association to CcaRegistrationEO
    @OneToMany(mappedBy = "ccaStatusRegistration")
    private List<RegistrationEO> ccaRegistrations;

    public StatusRegistrationEO() {}

    public int getIdStatusRegistration() {
        return this.idStatusRegistration;
    }

    public void setIdStatusRegistration(int idStatusRegistration) {
        this.idStatusRegistration = idStatusRegistration;
    }

    public String getStatusRegistration() {
        return this.statusRegistration;
    }

    public void setStatusRegistration(String statusRegistration) {
        this.statusRegistration = statusRegistration;
    }

    public List<RegistrationEO> getCcaRegistrations() {
        return this.ccaRegistrations;
    }

    public void setCcaRegistrations(List<RegistrationEO> ccaRegistrations) {
        this.ccaRegistrations = ccaRegistrations;
    }

    public RegistrationEO addCcaRegistration(RegistrationEO ccaRegistration) {
        getCcaRegistrations().add(ccaRegistration);
        ccaRegistration.setCcaStatusRegistration(this);

        return ccaRegistration;
    }

    public RegistrationEO removeCcaRegistration(RegistrationEO ccaRegistration) {
        getCcaRegistrations().remove(ccaRegistration);
        ccaRegistration.setCcaStatusRegistration(null);

        return ccaRegistration;
    }

}