package cz.cca.training.entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * <p>
 * Title: {@link TypeRelationshipEO}
 * </p>
 * <p>
 * Description: The persistent class for the cca_type_relationship database table.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 3. 2015 14:43:48
 */
@Entity
@Table(name = "cca_type_relationship")
@NamedQueries({
    @NamedQuery(name = "TypeRelationshipEO.all", query = "SELECT relation FROM TypeRelationshipEO relation")})
public class TypeRelationshipEO implements Serializable {
    private static final long serialVersionUID = 1L;

        public static final String ALL = "TypeRelationshipEO.all";
          
    @Id
    @Column(name = "id_type_relationship")
    private int idTypeRelationship;

    @Column(name = "abbreviation_relationship")
    private String abbreviationRelationship;

    @Column(name = "type_relationship")
    private String typeRelationship;

    // bi-directional many-to-one association to CcaEmployeeEO
    @OneToMany(mappedBy = "ccaTypeRelationship")
    private List<EmployeeEO> ccaEmployees;

    public TypeRelationshipEO() {}

    public int getIdTypeRelationship() {
        return this.idTypeRelationship;
    }

    public void setIdTypeRelationship(int idTypeRelationship) {
        this.idTypeRelationship = idTypeRelationship;
    }

    public String getAbbreviationRelationship() {
        return this.abbreviationRelationship;
    }

    public void setAbbreviationRelationship(String abbreviationRelationship) {
        this.abbreviationRelationship = abbreviationRelationship;
    }

    public String getTypeRelationship() {
        return this.typeRelationship;
    }

    public void setTypeRelationship(String typeRelationship) {
        this.typeRelationship = typeRelationship;
    }

    public List<EmployeeEO> getCcaEmployees() {
        return this.ccaEmployees;
    }

    public void setCcaEmployees(List<EmployeeEO> ccaEmployees) {
        this.ccaEmployees = ccaEmployees;
    }

    public EmployeeEO addCcaEmployee(EmployeeEO ccaEmployee) {
        getCcaEmployees().add(ccaEmployee);
        ccaEmployee.setCcaTypeRelationship(this);

        return ccaEmployee;
    }

    public EmployeeEO removeCcaEmployee(EmployeeEO ccaEmployee) {
        getCcaEmployees().remove(ccaEmployee);
        ccaEmployee.setCcaTypeRelationship(null);

        return ccaEmployee;
    }

}