package cz.cca.training.entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * <p>
 * Title: {@link UnitMeasureEO}
 * </p>
 * <p>
 * Description: The persistent class for the cca_unit_measure database table.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 3. 2015 14:43:35
 */
@Entity
@Table(name = "cca_unit_measure")
@NamedQueries({
    @NamedQuery(name = "UnitMeasureEO.all", query = "SELECT measure FROM UnitMeasureEO measure")})
public class UnitMeasureEO implements Serializable {
    private static final long serialVersionUID = 1L;

        public static final String ALL = "UnitMeasureEO.all";
        
    @Id
    @Column(name = "id_unit_measure")
    private int idUnitMeasure;

    @Column(name = "unit_measure")
    private String unitMeasure;

    // bi-directional many-to-one association to CcaRealizationActionEO
    @OneToMany(mappedBy = "ccaUnitMeasure")
    private List<RealizationActionEO> ccaRealizationActions;

    public UnitMeasureEO() {}

    public int getIdUnitMeasure() {
        return this.idUnitMeasure;
    }

    public void setIdUnitMeasure(int idUnitMeasure) {
        this.idUnitMeasure = idUnitMeasure;
    }

    public String getUnitMeasure() {
        return this.unitMeasure;
    }

    public void setUnitMeasure(String unitMeasure) {
        this.unitMeasure = unitMeasure;
    }

    public List<RealizationActionEO> getCcaRealizationActions() {
        return this.ccaRealizationActions;
    }

    public void setCcaRealizationActions(List<RealizationActionEO> ccaRealizationActions) {
        this.ccaRealizationActions = ccaRealizationActions;
    }

    public RealizationActionEO addCcaRealizationAction(RealizationActionEO ccaRealizationAction) {
        getCcaRealizationActions().add(ccaRealizationAction);
        ccaRealizationAction.setCcaUnitMeasure(this);

        return ccaRealizationAction;
    }

    public RealizationActionEO removeCcaRealizationAction(RealizationActionEO ccaRealizationAction) {
        getCcaRealizationActions().remove(ccaRealizationAction);
        ccaRealizationAction.setCcaUnitMeasure(null);

        return ccaRealizationAction;
    }

}