package cz.cca.training.rest;

import cz.cca.training.dao.EmployeeDAO;
import cz.cca.training.entity.CenterEO;
import cz.cca.training.rest.response.CenterJSON;
import cz.cca.training.utils.MapToJsonObject;
import java.util.LinkedList;
import java.util.List;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;


/**
 * <p>
 * Title: {@link CenterREST}
 * </p>
 * <p>
 * Description: Rest service to work with centers.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 4. 2015 16:21:41
 */
@Path("center")
public class CenterREST {

    @Inject
    private EmployeeDAO dao;

    @GET
    @Produces("application/json")
    public List<CenterJSON> getCenterList() {

        List<CenterEO> listEO = dao.getAllCenter();
        List<CenterJSON> listCenterJSON = new LinkedList<CenterJSON>();

        for (CenterEO item : listEO) {
            listCenterJSON.add(MapToJsonObject.mapToCenterJSON(item));
        }

        return listCenterJSON;
    }

   
}
