/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cca.training.rest;

import cz.cca.training.dao.RealizationActionDAO;
import cz.cca.training.entity.CurrencyEO;
import cz.cca.training.rest.response.CurrencyJSON;
import cz.cca.training.utils.MapToJsonObject;
import java.util.LinkedList;
import java.util.List;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

/**
 * <p>
 * Title: {@link CurrencyREST}
 * </p>
 * <p>
 * Description: Rest service to work with currency.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 4. 2015 16:25:23
 */
@Path("currency")
public class CurrencyREST {

    @Inject
    private RealizationActionDAO dao;

    @GET
    @Produces("application/json")
    public List<CurrencyJSON> getCurrencyList() {

        List<CurrencyEO> listEO = dao.getCurrencyList();
        List<CurrencyJSON> listCurencyJSON = new LinkedList<CurrencyJSON>();

        for (CurrencyEO item : listEO) {
            listCurencyJSON.add(MapToJsonObject.mapToCurrencyJSON(item));
        }

        return listCurencyJSON;
    }
}
