/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cca.training.rest;

import cz.cca.training.dao.RegistrationDAO;
import cz.cca.training.entity.ExpressionEO;
import cz.cca.training.rest.response.ExpressionJSON;
import cz.cca.training.utils.MapToJsonObject;
import java.util.LinkedList;
import java.util.List;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

/**
 * <p>
 * Title: {@link ExpressionREST}
 * </p>
 * <p>
 * Description: Rest service to work with expression.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 4. 2015 16:25:18
 */
@Path("expression")
public class ExpressionREST {
    
    @Inject
    private RegistrationDAO dao;

    @GET
    @Produces("application/json")
    public List<ExpressionJSON> getExpressionList() {

        List<ExpressionEO> listEO = dao.getExpressionStudentList();
        List<ExpressionJSON> listJSON = new LinkedList<ExpressionJSON>();

        for (ExpressionEO item : listEO) {
            listJSON.add(MapToJsonObject.mapToExpressionJSON(item));
        }

        return listJSON;
    }

}
