package cz.cca.training.rest;

import cz.cca.training.token.TokenManager;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import java.io.IOException;
import java.util.UUID;

/**
 * Created by 1Max11 on 2.4.2015.
 */
@Path("/")
public class LoginREST {

    private TokenManager tokenManager = TokenManager.getInstance();

    @POST
    public Response login(@Context HttpServletRequest req, @Context HttpServletResponse resp) throws IOException, ServletException {

        if (!req.authenticate(resp))
            return null;

        String token = UUID.randomUUID().toString();

        String role = req.isUserInRole("admin") ? "admin" : "user";


        tokenManager.addToken(token, role);


        return Response
                .status(Response.Status.ACCEPTED)
                .header("X-Token", token)
                .header("X-Role", role)
                .build();
    }

}
