/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cca.training.rest;

import cz.cca.training.dao.RealizationActionDAO;
import cz.cca.training.entity.StatusActionEO;
import cz.cca.training.rest.response.StatusActionJSON;
import cz.cca.training.utils.MapToJsonObject;
import java.util.LinkedList;
import java.util.List;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

/**
 * <p>
 * Title: {@link StatusActionREST}
 * </p>
 * <p>
 * Description: Rest service to work with status action.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 4. 2015 16:26:23
 */
@Path("statusAction")
public class StatusActionREST {

    @Inject
    private RealizationActionDAO dao;

    @GET
    @Produces("application/json")
    public List<StatusActionJSON> getStatusActionList() {

        List<StatusActionEO> listEO = dao.getStatusActionList();
        List<StatusActionJSON> listJSON = new LinkedList<StatusActionJSON>();

        for (StatusActionEO item : listEO) {
            listJSON.add(MapToJsonObject.mapToStatusActionJSON(item));
        }

        return listJSON;
    }
    
}
