/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cca.training.rest;

import cz.cca.training.dao.RegistrationDAO;
import cz.cca.training.entity.StatusRegistrationEO;
import cz.cca.training.rest.response.StatusRegistrationJSON;
import cz.cca.training.utils.MapToJsonObject;
import java.util.LinkedList;
import java.util.List;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

/**
 * <p>
 * Title: {@link RegistrationREST}
 * </p>
 * <p>
 * Description: Rest service to work with status registrations.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 20. 5. 2015 13:22:43
 */
@Path("statusRegistration")
public class StatusRegistrationREST {
    
    @Inject
    private RegistrationDAO dao;

    @GET
    @Produces("application/json")
    public List<StatusRegistrationJSON> getStatusRegistrationList() {

        
        List<StatusRegistrationEO> listEO = dao.getStatusRegistrationList();
        List<StatusRegistrationJSON> listStatusRegistrationJSON = new LinkedList<StatusRegistrationJSON>();

        for (StatusRegistrationEO item : listEO) {
            listStatusRegistrationJSON.add(MapToJsonObject.mapToStatusRegistrationJSON(item));
        }

        return listStatusRegistrationJSON;
    }
    
}
