/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cca.training.rest;

import cz.cca.training.dao.EmployeeDAO;
import cz.cca.training.entity.TypeRelationshipEO;
import cz.cca.training.rest.response.TypeRelationshipJSON;
import cz.cca.training.utils.MapToJsonObject;
import java.util.LinkedList;
import java.util.List;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

/**
 * <p>
 * Title: {@link TypeRelationshipREST}
 * </p>
 * <p>
 * Description: Rest service to work with type relationships.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 4. 2015 16:27:43
 */
@Path("typeRelationship")
public class TypeRelationshipREST {

    @Inject
    private EmployeeDAO dao;

    @GET
    @Produces("application/json")
    public List<TypeRelationshipJSON> getTypeRelationshipList() {

        List<TypeRelationshipEO> listTypeRelationshipEO = dao.getAllTypeRelationship();
        List<TypeRelationshipJSON> listTypeRelationshipJSON = new LinkedList<TypeRelationshipJSON>();

        for (TypeRelationshipEO item : listTypeRelationshipEO) {
            listTypeRelationshipJSON.add(MapToJsonObject.mapToTypeRelationshipJSON(item));
        }
        return listTypeRelationshipJSON;
    }
    
}
