/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cca.training.rest;

import cz.cca.training.dao.RealizationActionDAO;
import cz.cca.training.entity.UnitMeasureEO;
import cz.cca.training.rest.response.UnitMeasureJSON;
import cz.cca.training.utils.MapToJsonObject;
import java.util.LinkedList;
import java.util.List;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

/**
 * <p>
 * Title: {@link UnitMeasureREST}
 * </p>
 * <p>
 * Description: Rest service to work with unit measures.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 24. 4. 2015 16:27:58
 */
@Path("unitMeasure")
public class UnitMeasureREST {

    @Inject
    private RealizationActionDAO dao;

    @GET
    @Produces("application/json")
    public List<UnitMeasureJSON> getUnitMeasureList() {

        List<UnitMeasureEO> listnUnitMeasureEO = dao.getUnitMeasureList();
        List<UnitMeasureJSON> listUnitMeasureJSON = new LinkedList<UnitMeasureJSON>();

        for (UnitMeasureEO item : listnUnitMeasureEO) {
            listUnitMeasureJSON.add(MapToJsonObject.mapToUnitMeasureJSON(item));
        }
        return listUnitMeasureJSON;
    }
}
