package cz.cca.training.rest.response;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * Title: {@link EmployeeJSON}
 * </p>
 * <p>
 * Description: JSON with necessary properties about employee.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 17. 5. 2015 11:52:23
 */
public class EmployeeJSON implements Serializable {

    private static final long serialVersionUID = -5432738789730950950L;

    private int idEmployee;
    private Date dateRating;
    private String description;
    private String emailAddress;
    private String firstName;
    private int idLeader;
    private String personalCode;
    private String surname;
    private Date validityContract;
    private Date validityFrom;
    private Date validityInto;
    /*
        private CenterJSON ccaCenter;
    private TypeRelationshipJSON ccaTypeRelationship;
        private List<RegistrationJSON> ccaRegistrations;
        */
        private String center;
        private String typeRelationship;
      
        
        
    public int getIdEmployee() {
        return idEmployee;
    }

    public void setIdEmployee(int idEmployee) {
        this.idEmployee = idEmployee;
    }

    public Date getDateRating() {
        return dateRating;
    }

    public void setDateRating(Date dateRating) {
        this.dateRating = dateRating;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getEmailAddress() {
        return emailAddress;
    }

    public void setEmailAddress(String emailAddress) {
        this.emailAddress = emailAddress;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public int getIdLeader() {
        return idLeader;
    }

    public void setIdLeader(int idLeader) {
        this.idLeader = idLeader;
    }

    public String getPersonalCode() {
        return personalCode;
    }

    public void setPersonalCode(String personalCode) {
        this.personalCode = personalCode;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public Date getValidityContract() {
        return validityContract;
    }

    public void setValidityContract(Date validityContract) {
        this.validityContract = validityContract;
    }

    public Date getValidityFrom() {
        return validityFrom;
    }

    public void setValidityFrom(Date validityFrom) {
        this.validityFrom = validityFrom;
    }

    public Date getValidityInto() {
        return validityInto;
    }

    public void setValidityInto(Date validityInto) {
        this.validityInto = validityInto;
    }
        
        public String getCenter() {
        return center;
    }

    public void setCenter(String center) {
        this.center = center;
    }
        
          public String getTypeRelationship() {
        return typeRelationship;
    }

    public void setTypeRelationship(String typeRelationship) {
        this.typeRelationship = typeRelationship;
    }

    /* FULL */
    @Override
    public String toString() {
        return "EmployeeJSON [idEmployee=" + idEmployee + ", dateRating="
                + dateRating + ", description=" + description
                + ", emailAddress=" + emailAddress + ", firstName=" + firstName
                + ", idLeader=" + idLeader + ", personalCode=" + personalCode
                + ", surname=" + surname + ", validityContract="
                + validityContract + ", validityFrom=" + validityFrom
                + ", validityInto=" + validityInto + ", center=" + center
                + ", typeRelationship=" + typeRelationship + "]";
    }


        
}
