/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cca.training.utils;

import cz.cca.training.entity.ActionEO;
import cz.cca.training.entity.CenterEO;
import cz.cca.training.entity.CurrencyEO;
import cz.cca.training.entity.EmployeeEO;
import cz.cca.training.entity.ExpressionEO;
import cz.cca.training.entity.RealizationActionEO;
import cz.cca.training.entity.RegistrationEO;
import cz.cca.training.entity.StatusActionEO;
import cz.cca.training.entity.StatusRegistrationEO;
import cz.cca.training.entity.TypeRelationshipEO;
import cz.cca.training.entity.UnitMeasureEO;
import cz.cca.training.rest.response.ActionNewJSON;
import cz.cca.training.rest.response.ActionUpdateJSON;
import cz.cca.training.rest.response.EmployeeNewJSON;
import cz.cca.training.rest.response.EmployeeUpdateJSON;
import cz.cca.training.rest.response.RealizationActionNewJSON;
import cz.cca.training.rest.response.RealizationActionUpdateJSON;
import cz.cca.training.rest.response.RegistrationNewJSON;
import cz.cca.training.rest.response.RegistrationUpdateJSON;

/**
 * <p>
 * Title: {@link MapFromJson}
 * </p>
 * <p>
 * Description: Necessary methods for decode JSON sent from PL.
 * </p>
 * <p>
 * Copyright: Copyright (c) 2015 Kosek David
 * </p>
 * <p>
 * ZCU KIV/FAV
 * </p>
 *
 * @author david.kosek A14N0132P
 * @date 17. 5. 2015 11:56:43
 */
public class MapFromJson {
    
    
    public static EmployeeEO mapFromEmployeeNewJSON(EmployeeNewJSON emp, CenterEO center, TypeRelationshipEO relation) {
        EmployeeEO newEmp = new EmployeeEO();
        
        newEmp.setFirstName(emp.getFirstName());
        newEmp.setSurname(emp.getSurname());
        newEmp.setDescription(emp.getDescription());
        newEmp.setDateRating(emp.getDateRating());
        newEmp.setEmailAddress(emp.getEmailAddress());
        newEmp.setIdLeader(emp.getIdLeader());
        newEmp.setPersonalCode(emp.getPersonalCode());
        newEmp.setValidityContract(emp.getValidityContract());
        newEmp.setValidityFrom(emp.getValidityFrom());
        newEmp.setValidityInto(emp.getValidityInto());             
        newEmp.setCcaCenter(center);
        newEmp.setCcaTypeRelationship(relation);

        return newEmp;
    }
      
    public static EmployeeEO mapFromEmployeeUpdateJSON(EmployeeUpdateJSON updateEmp, EmployeeEO emp, CenterEO center, TypeRelationshipEO relation) {
        
        
        emp.setFirstName(updateEmp.getFirstName());
        emp.setSurname(updateEmp.getSurname());
        emp.setDescription(updateEmp.getDescription());
        emp.setDateRating(updateEmp.getDateRating());
        emp.setEmailAddress(updateEmp.getEmailAddress());
        emp.setIdLeader(updateEmp.getIdLeader());
        emp.setPersonalCode(updateEmp.getPersonalCode());
        emp.setValidityContract(updateEmp.getValidityContract());
        emp.setValidityFrom(updateEmp.getValidityFrom());
        emp.setValidityInto(updateEmp.getValidityInto());             
        emp.setCcaCenter(center);
        emp.setCcaTypeRelationship(relation);

        return emp;
    }

    public static ActionEO mapFromActionNewJSON(ActionNewJSON action) {
        ActionEO newAction = new ActionEO();
        
        newAction.setCodeAction(action.getCodeAction());
        newAction.setDescription(action.getDescription());
        newAction.setGuarantee(action.getGuarantee());
        newAction.setNameAction(action.getNameAction());
        newAction.setNote(action.getNote());
        
        return newAction;
    }
    
    public static ActionEO mapFromActionUpdateJSON(ActionEO action,ActionUpdateJSON actionUpdate) {
                
        action.setCodeAction(actionUpdate.getCodeAction());
        action.setDescription(actionUpdate.getDescription());
        action.setGuarantee(actionUpdate.getGuarantee());
        action.setNameAction(actionUpdate.getNameAction());
        action.setNote(actionUpdate.getNote());
        
        return action;
    }
    
     public static RegistrationEO mapFromRegistrationNewJSON(RegistrationNewJSON registration, EmployeeEO emp, ExpressionEO expression, StatusRegistrationEO status, RealizationActionEO realizationAction ){
        RegistrationEO newRegistration = new RegistrationEO();
         
        newRegistration.setCreatedRegistration(registration.getCreatedRegistration());
        newRegistration.setDateRegistration(registration.getDateRegistration());
        newRegistration.setNote(registration.getNote());
        newRegistration.setCcaEmployee(emp);
        newRegistration.setCcaExpression(expression);
        newRegistration.setCcaRealizationAction(realizationAction);
        newRegistration.setCcaStatusRegistration(status);
         
        return newRegistration;
     }
    
      public static RegistrationEO mapFromRegistrationUpdateJSON(RegistrationEO reg, RegistrationUpdateJSON registration, EmployeeEO emp, ExpressionEO expression, StatusRegistrationEO status, RealizationActionEO realizationAction ){
        
        reg.setCreatedRegistration(registration.getCreatedRegistration());
        reg.setDateRegistration(registration.getDateRegistration());
        reg.setNote(registration.getNote());
        reg.setCcaEmployee(emp);
        reg.setCcaExpression(expression);
        reg.setCcaRealizationAction(realizationAction);
        reg.setCcaStatusRegistration(status);
         
        return reg;
     }
     
     public static RealizationActionEO mapFromRealizationNewJSON(RealizationActionNewJSON realization, ActionEO action, UnitMeasureEO unit, StatusActionEO status, CurrencyEO currency){
        RealizationActionEO newRealization = new RealizationActionEO();
                
        newRealization.setCcaAction(action);
        newRealization.setCcaCurrency(currency);
        newRealization.setCcaStatusAction(status);
        newRealization.setCcaUnitMeasure(unit);
        newRealization.setCodeAction(action.getCodeAction());
        newRealization.setCompulsoryRatings(realization.getCompulsoryRatings());
        newRealization.setDateRealization(realization.getDateRealization());
        newRealization.setDescription(realization.getDescription());
        newRealization.setGuarantee(realization.getGuarantee());
        newRealization.setIntendedFor(realization.getIntendedFor());
        newRealization.setLength(realization.getLength());
        newRealization.setMaxParticipants(realization.getMaxParticipants());
        newRealization.setMinParticipants(realization.getMinParticipants());
        newRealization.setNameAction(realization.getNameAction());
        newRealization.setNote(realization.getNote());
        newRealization.setPlace(realization.getPlace());
        newRealization.setPrice(realization.getPrice());
        newRealization.setPublishRating(realization.getPublishRating());
        newRealization.setSinglePrice(realization.getSinglePrice());
        newRealization.setTrainer(realization.getTrainer());
        newRealization.setTransmissionReport(realization.getTransmissionReport());
         
        return newRealization;
     }
     
     public static RealizationActionEO mapFromRealizationUpdateJSON(RealizationActionEO realization, RealizationActionUpdateJSON realizationUpdate, ActionEO action, UnitMeasureEO unit, StatusActionEO status, CurrencyEO currency){
          
        realization.setCcaAction(action);
        realization.setCcaCurrency(currency);
        realization.setCcaStatusAction(status);
        realization.setCcaUnitMeasure(unit);
        realization.setCodeAction(action.getCodeAction());
        realization.setCompulsoryRatings(realizationUpdate.getCompulsoryRatings());
        realization.setDateRealization(realizationUpdate.getDateRealization());
        realization.setDescription(realizationUpdate.getDescription());
        realization.setGuarantee(realizationUpdate.getGuarantee());
        realization.setIntendedFor(realizationUpdate.getIntendedFor());
        realization.setLength(realizationUpdate.getLength());
        realization.setMaxParticipants(realizationUpdate.getMaxParticipants());
        realization.setMinParticipants(realizationUpdate.getMinParticipants());
        realization.setNameAction(realizationUpdate.getNameAction());
        realization.setNote(realizationUpdate.getNote());
        realization.setPlace(realizationUpdate.getPlace());
        realization.setPrice(realizationUpdate.getPrice());
        realization.setPublishRating(realizationUpdate.getPublishRating());
        realization.setSinglePrice(realizationUpdate.getSinglePrice());
        realization.setTrainer(realizationUpdate.getTrainer());
        realization.setTransmissionReport(realizationUpdate.getTransmissionReport());
         
        return realization;
     }
    
}
