﻿-- MySQL Script generated by MySQL Workbench
-- 03/22/15 15:05:49
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema CCA
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema CCA
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `CCA` DEFAULT CHARACTER SET utf8 COLLATE utf8_czech_ci ;
USE `CCA` ;

-- -----------------------------------------------------
-- Table `CCA`.`CCA_TYPE_RELATIONSHIP`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_TYPE_RELATIONSHIP` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_TYPE_RELATIONSHIP` (
  `id_type_relationship` INT NOT NULL AUTO_INCREMENT,
  `type_relationship` VARCHAR(16) NOT NULL,
  `abbreviation_relationship` CHAR(1) NOT NULL,
  PRIMARY KEY (`id_type_relationship`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_CENTERS`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_CENTERS` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_CENTERS` (
  `id_center` INT NOT NULL AUTO_INCREMENT,
  `code_center` VARCHAR(8) NOT NULL,
  `full_name_center` VARCHAR(128) NOT NULL,
  PRIMARY KEY (`id_center`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_EMPLOYEES`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_EMPLOYEES` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_EMPLOYEES` (
  `id_employee` INT NOT NULL AUTO_INCREMENT,
  `personal_code` VARCHAR(32) NOT NULL,
  `first_name` VARCHAR(255) NULL,
  `surname` VARCHAR(255) NULL,
  `description` TEXT NULL,
  `email_address` VARCHAR(255) NULL,
  `validity_from` DATETIME NULL,
  `validity_into` DATETIME NULL,
  `validity_contract` DATETIME NULL,
  `date_rating` DATETIME NULL,
  `id_leader` INT NULL,
  `id_type_relationship` INT NULL,
  `id_center` INT NOT NULL,
  PRIMARY KEY (`id_employee`),
  INDEX `fk_CCA_EMPLOYEES_CCA_TYPE_RELATIONSHIP1_idx` (`id_type_relationship` ASC),
  INDEX `fk_CCA_EMPLOYEES_CCA_CENTERS1_idx` (`id_center` ASC),
  CONSTRAINT `fk_CCA_EMPLOYEES_CCA_TYPE_RELATIONSHIP1`
    FOREIGN KEY (`id_type_relationship`)
    REFERENCES `CCA`.`CCA_TYPE_RELATIONSHIP` (`id_type_relationship`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_CCA_EMPLOYEES_CCA_CENTERS1`
    FOREIGN KEY (`id_center`)
    REFERENCES `CCA`.`CCA_CENTERS` (`id_center`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_ACTION`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_ACTION` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_ACTION` (
  `id_action` INT NOT NULL AUTO_INCREMENT,
  `code_action` VARCHAR(32) NOT NULL,
  `name_action` VARCHAR(255) NOT NULL,
  `guarantee` VARCHAR(255) NULL,
  `description` TEXT NULL,
  `note` TEXT NULL,
  PRIMARY KEY (`id_action`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_STATUS_ACTION`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_STATUS_ACTION` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_STATUS_ACTION` (
  `id_status_action` INT NOT NULL AUTO_INCREMENT,
  `status_action` VARCHAR(32) NOT NULL,
  PRIMARY KEY (`id_status_action`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_UNIT_MEASURE`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_UNIT_MEASURE` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_UNIT_MEASURE` (
  `id_unit_measure` INT NOT NULL AUTO_INCREMENT,
  `unit_measure` VARCHAR(16) NOT NULL,
  PRIMARY KEY (`id_unit_measure`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_CURRENCY`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_CURRENCY` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_CURRENCY` (
  `id_currency` INT NOT NULL AUTO_INCREMENT,
  `abbervivation_currency` VARCHAR(3) NOT NULL,
  `currency` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`id_currency`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_REALIZATION_ACTION`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_REALIZATION_ACTION` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_REALIZATION_ACTION` (
  `id_realization` INT NOT NULL AUTO_INCREMENT,
  `date_realization` DATETIME NOT NULL,
  `code_action` VARCHAR(32) NOT NULL,
  `name_action` VARCHAR(255) NOT NULL,
  `guarantee` VARCHAR(255) NULL,
  `trainer` VARCHAR(255) NULL,
  `place` VARCHAR(255) NULL,
  `length` INT NULL,
  `intended_for` VARCHAR(128) NULL,
  `single_price` TINYINT(1) NULL,
  `price` INT NULL,
  `min_participants` INT NULL,
  `max_participants` INT NULL,
  `description` TEXT NULL,
  `note` TEXT NULL,
  `compulsory_ratings` TINYINT(1) NOT NULL DEFAULT 0,
  `publish_rating` TINYINT(1) NOT NULL DEFAULT 0,
  `transmission_report` TINYINT(1) NOT NULL DEFAULT 0,
  `id_action` INT NOT NULL,
  `id_status_action` INT NOT NULL,
  `id_unit_measure` INT NOT NULL,
  `id_currency` INT NOT NULL,
  PRIMARY KEY (`id_realization`),
  INDEX `fk_CCA_REALIZATION_ACTION_CCA_ACTION1_idx` (`id_action` ASC),
  INDEX `fk_CCA_REALIZATION_ACTION_CCA_STATUS_ACTION1_idx` (`id_status_action` ASC),
  INDEX `fk_CCA_REALIZATION_ACTION_CCA_UNIT_MEASURE1_idx` (`id_unit_measure` ASC),
  INDEX `fk_CCA_REALIZATION_ACTION_CCA_CURRENCY1_idx` (`id_currency` ASC),
  CONSTRAINT `fk_CCA_REALIZATION_ACTION_CCA_ACTION1`
    FOREIGN KEY (`id_action`)
    REFERENCES `CCA`.`CCA_ACTION` (`id_action`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_CCA_REALIZATION_ACTION_CCA_STATUS_ACTION1`
    FOREIGN KEY (`id_status_action`)
    REFERENCES `CCA`.`CCA_STATUS_ACTION` (`id_status_action`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_CCA_REALIZATION_ACTION_CCA_UNIT_MEASURE1`
    FOREIGN KEY (`id_unit_measure`)
    REFERENCES `CCA`.`CCA_UNIT_MEASURE` (`id_unit_measure`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_CCA_REALIZATION_ACTION_CCA_CURRENCY1`
    FOREIGN KEY (`id_currency`)
    REFERENCES `CCA`.`CCA_CURRENCY` (`id_currency`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_STATUS_REGISTRATION`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_STATUS_REGISTRATION` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_STATUS_REGISTRATION` (
  `id_status_registration` INT NOT NULL AUTO_INCREMENT,
  `status_registration` VARCHAR(16) NOT NULL,
  PRIMARY KEY (`id_status_registration`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_EXPRESSION`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_EXPRESSION` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_EXPRESSION` (
  `id_expression` INT NOT NULL AUTO_INCREMENT,
  `expression` VARCHAR(16) NOT NULL,
  PRIMARY KEY (`id_expression`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `CCA`.`CCA_REGISTRATION`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `CCA`.`CCA_REGISTRATION` ;

CREATE TABLE IF NOT EXISTS `CCA`.`CCA_REGISTRATION` (
  `id_registration` INT NOT NULL AUTO_INCREMENT,
  `date_registration` DATETIME NOT NULL,
  `note` TEXT NULL,
  `created_registration` VARCHAR(255) NULL,
  `id_employee` INT NOT NULL,
  `id_status_registration` INT NOT NULL,
  `id_expression_student` INT NOT NULL,
  `id_realization` INT NOT NULL,
  PRIMARY KEY (`id_registration`),
  INDEX `fk_CCA_REGISTRATION_CCA_EMPLOYEES1_idx` (`id_employee` ASC),
  INDEX `fk_CCA_REGISTRATION_CCA_STATUS1_idx` (`id_status_registration` ASC),
  INDEX `fk_CCA_REGISTRATION_CCA_EXPRESSION1_idx` (`id_expression_student` ASC),
  INDEX `fk_CCA_REGISTRATION_CCA_REALIZATION_ACTION1_idx` (`id_realization` ASC),
  CONSTRAINT `fk_CCA_REGISTRATION_CCA_EMPLOYEES1`
    FOREIGN KEY (`id_employee`)
    REFERENCES `CCA`.`CCA_EMPLOYEES` (`id_employee`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_CCA_REGISTRATION_CCA_STATUS1`
    FOREIGN KEY (`id_status_registration`)
    REFERENCES `CCA`.`CCA_STATUS_REGISTRATION` (`id_status_registration`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_CCA_REGISTRATION_CCA_EXPRESSION1`
    FOREIGN KEY (`id_expression_student`)
    REFERENCES `CCA`.`CCA_EXPRESSION` (`id_expression`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_CCA_REGISTRATION_CCA_REALIZATION_ACTION1`
    FOREIGN KEY (`id_realization`)
    REFERENCES `CCA`.`CCA_REALIZATION_ACTION` (`id_realization`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;


ALTER TABLE  `cca_employees` CHANGE  `validity_from`  `validity_from` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP ;

ALTER TABLE  `cca_employees` CHANGE  `id_type_relationship`  `id_type_relationship` INT( 11 ) NULL DEFAULT  '1';

ALTER TABLE  `cca_registration` CHANGE  `id_expression_student` `id_expression_student` INT( 11 ) NOT NULL DEFAULT  '2';

-- TABLE centers
INSERT INTO `cca`.`cca_centers` (`id_center`, `code_center`) VALUES (NULL, 'ZP'), (NULL, 'EÚ'), (NULL, 'AP'), (NULL, 'VP'), (NULL, 'SN'), (NULL, 'PROV');

-- TABLE type_relatioship
INSERT INTO `cca`.`cca_type_relationship` (`id_type_relationship` ,`type_relationship`) VALUES (NULL ,  'Interní'), (NULL ,  'Externí');

-- TABLE expression
INSERT INTO `cca`.`cca_expression` (`id_expression`, `expression`) VALUES (NULL, 'Akceptováno'), (NULL, 'Neakceptováno');

-- TABLE empoloyees
INSERT INTO `cca_employees` (`id_employee`, `personal_code`, `first_name`, `surname`, `description`, `email_address`, `validity_from`, `validity_into`, `validity_contract`, `date_rating`, `id_leader`, `id_type_relationship`, `id_center`) VALUES
(NULL, 'ARN', 'Lenka', 'Andrlová', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 1),
(NULL, 'ILO', 'Ilona', 'Aubrechtová', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 3),
(NULL, 'CER', 'Kateřina', 'Bártová', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 4),
(NULL, 'BEM', 'Martin', 'Bělohlavý', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 2),
(NULL, 'BIK', 'Martin', 'Bíkl', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 6),
(NULL, 'BOB', 'Jarmila', 'Bobková', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 1),
(NULL, 'BRY', 'Zdeněk', 'Brýdl', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 5),
(NULL, 'BRS', 'Lukáš', 'Bureš', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 2, 4),
(NULL, 'BUP', 'Petr', 'Burian', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 3),
(NULL, 'CAB', 'Ondřej', 'Čabrada', NULL, 'example@cca.com', CURRENT_TIMESTAMP, NULL, NULL, NULL, 2, 1, 2);

-- TABLE currency
INSERT INTO  `cca`.`cca_currency` (`id_currency` ,`abbervivation_currency` ,`currency`) VALUES 
(NULL ,  'CZK',  'Česká Republika, koruna'), 
(NULL ,  'EUR',  'EMU, euro'), 
(NULL ,  'GBP',  'Velká Británie, libra'), 
(NULL ,  'USD',  'USA, dolar'), 
(NULL ,  'RUB',  'Rusko, rubl');

-- TABLE status registration
INSERT INTO  `cca`.`cca_status_registration` (`id_status_registration` ,`status_registration`) VALUES
(NULL ,  'vloženo'), 
(NULL ,  'nevloženo');

-- TABLE status action (realization)
INSERT INTO  `cca`.`cca_status_action` (`id_status_action` ,`status_action`) VALUES 
(NULL ,  'volno'), 
(NULL ,  'obsazeno'), 
(NULL ,  'rezervováno');

-- TABLE unit measure
INSERT INTO  `cca`.`cca_unit_measure` (`id_unit_measure` ,`unit_measure`) VALUES 
(NULL ,  'hodina'), 
(NULL ,  'den'), 
(NULL ,  'týden');

-- TABLE action
INSERT INTO  `cca`.`cca_action` (`id_action` ,`code_action` ,`name_action` ,`guarantee` ,`description` ,`note`) VALUES 
(NULL ,  'JAVA-01',  'Úvod do programování v JAVA',  'CCA', 'Kurz je vhodný pro studenty středních a vysokých škol. Cílem akce je účastníky seznámit se základy programování v JAVA.', NULL),
(NULL ,  'JAVA-02',  'Pokročilé programování v JAVA',  'CCA', 'Kurz je vhodný pro zájemce, kteří si chtějí prohloubit znalosti v programovacím jazyce JAVA.', NULL),
(NULL ,  'JPA-01',  'Jak správně využívat JPA',  'CCA', 'Cílem akce je účastníky seznámit se základy mapování a jak správně psát dotazy.', NULL),
(NULL ,  'SH-01',  'Úvod do technologií Spring a Hibernate',  'CCA', 'Kurz pro získání elementárních znalostí ze soudku Spring a Hibernate.', NULL);

-- TABLE realization action
INSERT INTO `cca`.`cca_realization_action` (`id_realization`, `date_realization`, `code_action`, `name_action`, `guarantee`, `trainer`, `place`, `length`, `intended_for`, `single_price`, `price`, `min_participants`, `max_participants`, `description`, `note`, `compulsory_ratings`, `publish_rating`, `transmission_report`, `id_action`, `id_status_action`, `id_unit_measure`, `id_currency`) VALUES 
(NULL, '2015-05-26 13:00:00', 'JAVA-01', 'Úvod do programování v JAVA', 'CCA', 'Vladimír Koláček', 'CCA', '5', NULL, NULL, '2000', '5', '15', 'Kurz je vhodný pro studenty středních a vysokých škol. Cílem akce je účastníky seznámit se základy programování v JAVA.', NULL, '0', '0', '0', '1', '1', '1', '1'),
(NULL, '2015-05-28 13:00:00', 'JAVA-02', 'Pokročilé programování v JAVA', 'CCA', 'Vladimír Koláček', 'CCA', '6', NULL, NULL, '2500', '5', '15', 'Kurz je vhodný pro zájemce, kteří si chtějí prohloubit znalosti v programovacím jazyce JAVA.', NULL, '0', '0', '0', '2', '1', '1', '1');

-- TABLE registration
INSERT INTO `cca`.`cca_registration` (`id_registration`, `date_registration`, `note`, `created_registration`, `id_employee`, `id_status_registration`, `id_expression_student`, `id_realization`) VALUES 
(NULL, '2015-04-26 15:28:10', NULL, NULL, '2', '1', '1', '1'),
(NULL, '2015-04-26 15:29:10', NULL, NULL, '3', '1', '1', '1'),
(NULL, '2015-04-26 15:30:10', NULL, NULL, '4', '1', '2', '1'),
(NULL, '2015-04-26 15:31:10', NULL, NULL, '5', '1', '1', '1'),
(NULL, '2015-04-26 15:32:10', NULL, NULL, '6', '2', '1', '2'),
(NULL, '2015-04-26 15:33:10', NULL, NULL, '7', '1', '1', '2');




