angular
.module('realForm.controller', [])
.controller('realizationForm', ['$scope', '$http', '$routeParams', '$localStorage',
    function ($scope, $http, $routeParams, $localStorage){
        var create = false;
        if($routeParams.realizationId===undefined){
            //do create
            $scope.realizationFormTitle = 'Realization create';
            create = true;
        }else {
        
            $scope.realizationFormTitle = 'Realization edit';
            $scope.master = {};
            $http.get("/training/api/realizationAction/detail/" + $routeParams.realizationId)
                .success(function (response) {
                    console.log("Response:", response);
                    $scope.realizationForm = response;
                    $scope.realizationForm.dateRealization = new Date(response.dateRealization);
            }); 
        }
        
        $scope.actions = [{ id: 0, name: '-- Choose action --' }];
        $scope.selectedAction = 0;
        $http.get("/training/api/action/")
            .success(function (response) {
                response.forEach(function(value){
                    if($scope.realizationForm !== undefined && value.codeAction===$scope.realizationForm.codeAction){
                        $scope.selectedAction = value.idAction;
                    }
                    $scope.actions.push({ id: value.idAction, name: value.nameAction + " [" + value.codeAction  + "]" });
                });
        });
        
        $scope.currencies = [{ id: 0, name: '-- Choose currency --' }];
        $scope.selectedCurrency = 0;
        $http.get("/training/api/currency/")
            .success(function (response) {
                response.forEach(function(value){
                    if($scope.realizationForm !== undefined && value.idCurrency===$scope.realizationForm.ccaCurrency.idCurrency){
                        $scope.selectedCurrency = value.idCurrency;
                    }
                    $scope.currencies.push({ id: value.idCurrency, name: value.abbervivationCurrency });
                });
        });
        
        $scope.statuses = [{ id: 0, name: '-- Choose action status --' }];
        $scope.selectedStatus = 0;
        $http.get("/training/api/statusAction/")
            .success(function (response) {
//                console.log("Action statuses: ", response);
                response.forEach(function(value){
                    if($scope.realizationForm !== undefined && value.idStatusAction===$scope.realizationForm.ccaStatusAction.idStatusAction){
                        $scope.selectedStatus = value.idStatusAction;
                    }
                    $scope.statuses.push({ id: value.idStatusAction, name: value.statusAction });
                });
        });
        
        $scope.units = [{ id: 0, name: '-- Choose unit measure --' }];
        $scope.selectedUnit = 0;
        $http.get("/training/api/unitMeasure/")
            .success(function (response) {
//                console.log("Units: ", response);
                response.forEach(function(value){
                    if($scope.realizationForm !== undefined && value.idUnitMeasure===$scope.realizationForm.ccaUnitMeasure.idUnitMeasure){
                        $scope.selectedUnit = value.idUnitMeasure;
                    }
                    $scope.units.push({ id: value.idUnitMeasure, name: value.unitMeasure });
                });
        });
        
        //function for doing update
        $scope.update = function(realizationForm, selectedAction, selectedCurrency, selectedStatus, selectedUnit) {
            console.log("Form data: ", realizationForm);
            $scope.master = {
                "idAction": selectedAction,
                "idCurrency": selectedCurrency,
                "idStatusAction": selectedStatus,
                "idUnitMeasure": selectedUnit,
                "compulsoryRatings": realizationForm.compulsoryRatings===undefined?'0':realizationForm.compulsoryRatings,
                "dateRealization": realizationForm.dateRealization===undefined?formatLocalDate(new Date()):formatLocalDate(realizationForm.dateRealization),//"2015-04-28T10:33:32+02:00
                "description": realizationForm.description===undefined?null:realizationForm.description,
                "guarantee": realizationForm.guarantee===undefined?null:realizationForm.guarantee,
                "intendedFor": realizationForm.intendedFor===undefined?null:realizationForm.intendedFor,
                "length": realizationForm.length===undefined?'1':realizationForm.length,
                "maxParticipants": realizationForm.maxParticipants===undefined?'15':realizationForm.maxParticipants,
                "minParticipants": realizationForm.minParticipants===undefined?'5':realizationForm.minParticipants,
                "nameAction": realizationForm.nameAction===undefined?null:realizationForm.nameAction,
                "note": realizationForm.note===undefined?null:realizationForm.note,
                "place": realizationForm.place===undefined?null:realizationForm.place,
                "price": realizationForm.price===undefined?'2000':realizationForm.price,
                "publishRating": realizationForm.publishRating===undefined?'0':realizationForm.publishRating,
                "singlePrice": realizationForm.singlePrice===undefined?'0':realizationForm.singlePrice,
                "trainer": realizationForm.trainer===undefined?null:realizationForm.trainer,
                "transmissionReport": realizationForm.transmissionReport===undefined?'0':realizationForm.transmissionReport
            }
            var method;
            if(create){
                method = $http.put("/training/api/realizationAction/create",$scope.master);
            }else {
                $scope.master.idRealizationAction = realizationForm.idRealization;
                method = $http.post("/training/api/realizationAction",$scope.master);
            }
            console.log("Updated data: ",$scope.master);
            method.success(function (response, status) {
                console.log(status, response);
                if(create)
                    $localStorage.msg = "Create realization success.";
                else
                    $localStorage.msg = "Update realization success.";
                window.location.href = '#/realizations';
            }).
            error(function(data, status, headers) {
                console.log("ERROR "+status+": realization update");
                console.log(headers('X-Error-Message'));
            });
        };
        
        function formatLocalDate(now) {
                tzo = -now.getTimezoneOffset(),
                dif = tzo >= 0 ? '+' : '-',
                pad = function(num) {
                    var norm = Math.abs(Math.floor(num));
                    return (norm < 10 ? '0' : '') + norm;
                };
            return now.getFullYear() 
                + '-' + pad(now.getMonth()+1)
                + '-' + pad(now.getDate())
                + 'T' + pad(now.getHours())
                + ':' + pad(now.getMinutes()) 
                + ':' + pad(now.getSeconds()) 
                + dif + pad(tzo / 60) 
                + ':' + pad(tzo % 60);
        }
    }]);


