angular
.module('regForm.controller', [])
.controller('registrationForm', ['$scope', '$http', '$routeParams', '$localStorage',
    function ($scope, $http, $routeParams, $localStorage){
        var create = false;
        if($routeParams.registrationId===undefined){
            //do create
            $scope.registrationFormTitle = 'Registration create';
            create = true;
        }else {
        
            $scope.registrationFormTitle = 'Registration edit';
            $scope.master = {};
            $http.get("/training/api/registration/detail/" + $routeParams.registrationId)
                .success(function (response) {
                    console.log("Response:", response);
                    $scope.registrationForm = response;
                    $scope.registrationForm.dateRegistration = new Date(response.dateRegistration);
            }); 
        }
        
        
        $scope.employees =  [{ id: 0, name: '-- Choose employee --' }];
        $scope.selectedEmployee = 0;
        $http.get("/training/api/employee/")
            .success(function (response) {
                response.forEach(function(value){
                    if($scope.registrationForm !== undefined && value.idEmployee===$scope.registrationForm.ccaEmployee.idEmployee){
                        $scope.selectedEmployee = value.idEmployee;
                    }
                    $scope.employees.push({ id: value.idEmployee, name: value.firstName + " " + value.surname });
                });
        });
        
        $scope.statuses = [{ id: 0, name: '-- Choose registration status --' }];
        $scope.selectedStatus = 0;
        $http.get("/training/api/statusRegistration/")
            .success(function (response) {
                console.log("Registration statuses: ", response);
                console.log("Choose Registration status: ", $scope.registrationForm.ccaStatusRegistration.idStatusRegistration);
                response.forEach(function(value){
                    if($scope.registrationForm !== undefined && value.idStatusRegistration===$scope.registrationForm.ccaStatusRegistration.idStatusRegistration){
                        $scope.selectedStatus = value.idStatusRegistration;
                    }
                    $scope.statuses.push({ id: value.idStatusRegistration, name: value.statusRegistration });
                });
        });
        
        $scope.expressions = [{ id: 0, name: '-- Choose expression --' }];
        $scope.selectedExpression = 0;
        $http.get("/training/api/expression/")
            .success(function (response) {
//                console.log("Expressions: ", response);
                response.forEach(function(value){
                    if($scope.registrationForm !== undefined && value.idExpression===$scope.registrationForm.ccaExpression.idExpression){
                        $scope.selectedExpression = value.idExpression;
                    }
                    $scope.expressions.push({ id: value.idExpression, name: value.expression });
                });
        });
        
        $scope.realizations = [{ id: 0, name: '-- Choose realization --' }];
        $scope.selectedRealization = 0;
        $http.get("/training/api/realizationAction/")
            .success(function (response) {
//                console.log("Realizations: ", response);
                response.forEach(function(value){
                    if($scope.registrationForm !== undefined && value.idRealization===$scope.registrationForm.realizationAction.idRealization){
                        $scope.selectedRealization = value.idRealization;
                    }
                    $scope.realizations.push({ id: value.idRealization, name: value.nameAction });
                });
        });
        
        //function for doing update
        $scope.update = function(registrationForm, selectedEmployee, selectedRealization, selectedStatus, selectedExpression) {
            $scope.master = {
                "compulsoryRatings": registrationForm.compulsoryRatings===undefined?'0':registrationForm.compulsoryRatings,
                "idEmployee": selectedEmployee,
                "idExpression": selectedExpression,
                "idStatusRegistration": selectedStatus,
                "idRealizationAction": selectedRealization,
                "createdRegistration": registrationForm.createdRegistration===undefined?null:registrationForm.createdRegistration,
                "note": registrationForm.note===undefined?null:registrationForm.note,
                "dateRegistration": "2015-04-28T10:33:32+02:00"
            }
            var method;
            if(create){
                method = $http.put("/training/api/registration/create",$scope.master);
            }else {
                $scope.master.idRegistration = registrationForm.idRegistration;
                method = $http.post("/training/api/registration",$scope.master);
            }
            console.log("Updated data: ",$scope.master);
            method.success(function (response, status) {
                console.log(status, response);
                if(create)
                    $localStorage.msg = "Create registration success.";
                else
                    $localStorage.msg = "Update registration success.";
                window.location.href = '#/registrations';
            }).
            error(function(data, status, headers) {
                console.log("ERROR "+status+": registration update");
                console.log(headers('X-Error-Message'));
            });
        };
        
        function formatLocalDate(now) {
                tzo = -now.getTimezoneOffset(),
                dif = tzo >= 0 ? '+' : '-',
                pad = function(num) {
                    var norm = Math.abs(Math.floor(num));
                    return (norm < 10 ? '0' : '') + norm;
                };
            return now.getFullYear() 
                + '-' + pad(now.getMonth()+1)
                + '-' + pad(now.getDate())
                + 'T' + pad(now.getHours())
                + ':' + pad(now.getMinutes()) 
                + ':' + pad(now.getSeconds()) 
                + dif + pad(tzo / 60) 
                + ':' + pad(tzo % 60);
        }
    }]);


