angular
.module('userEdit.controller', [])
.controller('UserEdit', ['$scope', '$http', '$routeParams', '$localStorage',
    function ($scope, $http, $routeParams, $localStorage){
        var create = false;
        if($routeParams.userId===undefined){
            //do create
            $scope.userFormTitle = 'User create';
            create = true;
        }else {
        
            $scope.userFormTitle = 'User edit';
            $scope.master = {};
            $http.get("/training/api/employee/detail/" + $routeParams.userId)
                .success(function (response) {
                    console.log("Response:", response);
                    $scope.userForm = response;
                    $scope.selectedLeader = response.idLeader;
            }); 
        }
        
        console.log("Create: ", create);
        
        $scope.leaders = [{ id: 0, name: '-- Choose leader --' }];
        $http.get("/training/api/employee/leaders")
            .success(function (response) {
                response.forEach(function(value){
                    $scope.leaders.push({ id: value.idEmployee, name: value.name });
                });
        });
        
        $scope.relationships = [{ id: 0, name: '-- Choose type relationship --' }];
        $scope.selectedRelationship = 0;
        $http.get("/training/api/typeRelationship/")
            .success(function (response) {
                response.forEach(function(value){
                    if($scope.userForm !== undefined && value.typeRelationship===$scope.userForm.typeRelationship){
                        $scope.selectedRelationship = value.idTypeRelationship;
                    }
                    $scope.relationships.push({ id: value.idTypeRelationship, name: value.typeRelationship });
                });
        });
        
        $scope.centers = [{ id: 0, name: '-- Choose center --' }];
        $scope.selectedCenter = 0;
        $http.get("/training/api/center/")
            .success(function (response) {
                response.forEach(function(value){
                    if($scope.userForm !== undefined && value.codeCenter===$scope.userForm.center){
                        $scope.selectedCenter = value.idCenter;
                    }
                    $scope.centers.push({ id: value.idCenter, name: value.codeCenter });
                });
        });
        
        //function for doing update
        $scope.update = function(userForm, selectedLeader, selectedCenter, selectedRelationship) {
            $scope.master = {
                "emailAddress": userForm.emailAddress,
                "firstName": userForm.firstName,
                "idLeader": selectedLeader,
                "personalCode": userForm.personalCode,
                "surname": userForm.surname,
                "idTypeRelationship": selectedRelationship,
                "validityFrom": userForm.validityFrom===undefined?null:userForm.validityFrom,
                "idCenter": selectedCenter,
                "description": userForm.description===undefined?null:userForm.description,
                "dateRating": userForm.dateRating===undefined?null:userForm.dateRating,
                "validityContract": userForm.validityContract===undefined?null:userForm.validityContract,
                "validityInto": userForm.validityInto===undefined?null:userForm.validityInto
            }
            console.log("Updated data: ",$scope.master);
            var method;
            if(create){
                $scope.master.validityFrom = new Date();
                method = $http.put("/training/api/employee/create",$scope.master);
            }else {
                $scope.master.idEmployee = userForm.idEmployee;
                method = $http.post("/training/api/employee",$scope.master);
            }
            method.success(function (response, status) {
                console.log(status, response);
                if(create)
                    $localStorage.msg = "Create user success.";
                else
                    $localStorage.msg = "Update user success.";
                window.location.href = '#/users';
            }).
            error(function(data, status, headers) {
                console.log("ERROR "+status+": user update");
                console.log(headers('X-Error-Message'));
            });
        };
    }]);


